<?php

namespace Seka\Portal\Modul\Vzdelavanie\Http\Controllers\Frontend\Kniznica;

use Exception;
use Illuminate\Support\Facades\Log;
use Seka\Portal\Modul\Vzdelavanie\Dtos\Kniznica\SekciaCollectionDTO;
use Seka\Portal\Modul\Vzdelavanie\Dtos\Kniznica\SekciaDTO;
use Seka\Portal\Modul\Vzdelavanie\Events\Kniznica\Frontend\SekciaOpened;
use Seka\Portal\Modul\Vzdelavanie\Http\Controllers\Controller;
use Seka\Portal\Modul\Vzdelavanie\Services\Kniznica\NavigaciaSekciamiUcebnehoMaterialuFactory;
use Seka\Portal\Modul\Vzdelavanie\Services\SekciaServiceInterface;
use Seka\Portal\Modul\Vzdelavanie\Services\UcebnicaServiceInterface;

/**
 * Class SekciaController
 *
 * @package Seka\Portal\Modul\Vzdelavanie\Http\Controllers\Frontend\Kniznica
 */
final class SekciaController extends Controller
{
    /**
     * @var \Seka\Portal\Modul\Vzdelavanie\Services\SekciaServiceInterface
     */
    protected $sekciaService;

    /**
     * @var \Seka\Portal\Modul\Vzdelavanie\Services\UcebnicaServiceInterface
     */
    protected $ucebnyMaterialService;

    /**
     * SekciaController constructor.
     *
     * @param \Seka\Portal\Modul\Vzdelavanie\Services\SekciaServiceInterface   $sekciaService
     * @param \Seka\Portal\Modul\Vzdelavanie\Services\UcebnicaServiceInterface $ucebnyMaterialService
     */
    public function __construct(
        SekciaServiceInterface $sekciaService,
        UcebnicaServiceInterface $ucebnyMaterialService,
    ) {
        $this->sekciaService = $sekciaService;
        $this->ucebnyMaterialService = $ucebnyMaterialService;
    }

    /**
     * @param int $ucebnicaId
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public function index(int $ucebnicaId)
    {
        $sekcie = null;
        $ucebnica = null;

        try {
            $ucebnica = $this->ucebnyMaterialService->vratUcebnyText($ucebnicaId);
            $sekcie = $this->sekciaService->vratZoznamSekciiUcebnehoTextu($ucebnicaId, true);
        } catch (Exception $e) {
            Log::error($e->getMessage(), $e->getTrace());

            flash()->error($e->getMessage())->important();
        } finally {
            return view('Vzdelavanie::pages.kniznica.sekcie.index', compact('sekcie', 'ucebnica'));
        }
    }

    /**
     * @param int $vzdKnzncUcbnMtrlId
     * @param int $vzdKnzncSekciaId
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public function show(int $vzdKnzncUcbnMtrlId, int $vzdKnzncSekciaId)
    {
        $sekcia = null;
        $sekcie = null;
        $ucebnyText = null;
        $navigacia = null;

        try {
            $ucebnyText = $this->ucebnyMaterialService->vratUcebnyText($vzdKnzncUcbnMtrlId);
            $sekcia = $this->sekciaService->vratSekciu($vzdKnzncSekciaId);
            $sekcie = $this->sekciaService->vratZoznamSekciiUcebnehoTextu($ucebnyText->getKey(), true);
            $sekcie = SekciaCollectionDTO::fromCollection($sekcie);

            $navigacia = NavigaciaSekciamiUcebnehoMaterialuFactory::navigacia(
                $this->sekciaService->vratZoznamSekciiUcebnehoTextu($vzdKnzncUcbnMtrlId, false),
                $sekcia,
                $ucebnyText,
                'vzdelavanie.kniznica.ucebnica.sekcia.show',
            );

            event(new SekciaOpened(SekciaDTO::fromModel($sekcia)));
        } catch (Exception $e) {
            Log::error($e->getMessage(), $e->getTrace());

            flash()->error($e->getMessage())->important();
        } finally {
            return view(
                'Vzdelavanie::pages.kniznica.ucebne_materialy.show',
                compact('sekcia', 'sekcie', 'ucebnyText', 'navigacia'),
            );
        }
    }
}
